//+---------------------------------------------------------------------+ 
//|                                                    ColorCoppock.mq5 | 
//|                                     Copyright  2010, EarnForex.com | 
//|                                           http://www.earnforex.com/ | 
//+---------------------------------------------------------------------+ 
//|          SmoothAlgorithms.mqh |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+ 
#property copyright "Copyright  2010, EarnForex.com"
#property link "http://www.earnforex.com/" 
//----   
#property version   "1.00"
//----     
#property indicator_separate_window 
//----    2
#property indicator_buffers 2 
//----     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----      
#property indicator_type1 DRAW_COLOR_HISTOGRAM
//----      
#property indicator_color1 clrDeepPink,clrFireBrick,clrGray,clrTeal,clrSpringGreen
//----   - 
#property indicator_style1 STYLE_SOLID
//----     2
#property indicator_width1 2
//----   
#property indicator_label1 "Coppock"

//+-----------------------------------+
//|          |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+

//----    CXMA   SmoothAlgorithms.mqh
CXMA XMA1;
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum Applied_price_ // 
  {
   PRICE_CLOSE_ = 1,     //Close
   PRICE_OPEN_,          //Open
   PRICE_HIGH_,          //High
   PRICE_LOW_,           //Low
   PRICE_MEDIAN_,        //Median Price (HL/2)
   PRICE_TYPICAL_,       //Typical Price (HLC/3)
   PRICE_WEIGHTED_,      //Weighted Close (HLCC/4)
   PRICE_SIMPL_,         //Simpl Price (OC/2)
   PRICE_QUARTER_,       //Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  //TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_,  //TrendFollow_2 Price
   PRICE_DEMARK_         //Demark Price
  };
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+-----------------------------------+
//|         |
//+-----------------------------------+
input int ROC1Period=14; //  
input int ROC2Period=10; //  
input Smooth_Method XMA_Method=MODE_LWMA; //  
input int XMA_Period=12; //  
input int XMA_Phase=100;  //  ,
                       // JJMA    -100 ... +100,     ;
//  VIDIA   CMO,  AMA    
input Applied_price_ AppliedPrice=PRICE_CLOSE_;// 
/* ,      ( 1-CLOSE, 2-OPEN, 3-HIGH, 4-LOW, 
  5-MEDIAN, 6-TYPICAL, 7-WEIGHTED, 8-SIMPL, 9-QUARTER, 10-TRENDFOLLOW, 11-0.5 * TRENDFOLLOW.) */
//+-----------------------------------+
//----      
int min_rates_,min_rates_total;
//----   ,    
//      
double CoppBuffer[],ColorCoppBuffer[];
//+------------------------------------------------------------------+
//   iPriceSeries                                     |
//   Moving_Average                                    | 
//+------------------------------------------------------------------+ 
#include <SmoothAlgorithms.mqh> 
//+------------------------------------------------------------------+    
//| Coppock indicator initialization function                        | 
//+------------------------------------------------------------------+  
void OnInit()
  {
//----     
   min_rates_=MathMax(ROC1Period,ROC2Period); 
   min_rates_total=min_rates_+XMA1.GetStartBars(XMA_Method,XMA_Period,XMA_Phase);

//----    CoppBuffer   
   SetIndexBuffer(0,CoppBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total+1);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----     ,     
   SetIndexBuffer(1,ColorCoppBuffer,INDICATOR_COLOR_INDEX);
   
//----      
   string shortname;
   string Smooth=XMA1.GetString_MA_Method(XMA_Method);
   StringConcatenate(shortname,"Coppock( ",ROC1Period,", ",ROC2Period,", ",XMA_Period,", ",XMA_Phase,", ",Smooth," )");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----  
  }
//+------------------------------------------------------------------+  
//| Coppock iteration function                                       | 
//+------------------------------------------------------------------+  
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(rates_total<min_rates_total) return(0);

//----   
   int first,bar;
//----       
   double price_0,price_1,price_2,ROCSum,XROCSum;

//----     OnCalculate()
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      first=min_rates_; //        
     }
   else //      
     {
      first=prev_calculated-1;
     }

//----    
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      price_0=PriceSeries(AppliedPrice,bar,open,low,high,close);
      price_1=PriceSeries(AppliedPrice,bar-ROC1Period,open,low,high,close);
      price_2=PriceSeries(AppliedPrice,bar-ROC2Period,open,low,high,close);  
      ROCSum=(price_0-price_1)/price_1+(price_0-price_2)/price_2;          
      XROCSum=XMA1.XMASeries(min_rates_,prev_calculated,rates_total,XMA_Method,XMA_Phase,XMA_Period,ROCSum,bar,false);

      //----      
      CoppBuffer[bar]=XROCSum;
      ColorCoppBuffer[bar]=2;

      if(XROCSum>0)
        {
         if(XROCSum>CoppBuffer[bar-1]) ColorCoppBuffer[bar]=4;
         if(XROCSum<CoppBuffer[bar-1]) ColorCoppBuffer[bar]=3;
        }

      if(XROCSum<0)
        {
         if(XROCSum<CoppBuffer[bar-1]) ColorCoppBuffer[bar]=0;
         if(XROCSum>CoppBuffer[bar-1]) ColorCoppBuffer[bar]=1;
        }
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
